{-# OPTIONS --injective-type-constructors #-}
module CantorEqInSet0 where

  data Empty : Set where

  data One : Set where
    one : One

  data Eq {A : Set1} (x : A) : A -> Set where
    refl : Eq x x

  data coprod (A B : Set1) : Set1 where
    inl : (a : A) -> coprod A B
    inr : (b : B) -> coprod A B

  postulate em : (A : Set1) -> coprod A (A -> Empty)

  data I (x : Set -> Set) : Set where

  data invI (a : Set) : Set1 where
    inv : (x : Set -> Set) -> Eq (I x) a -> invI a

  cantor : Set -> Set
  cantor a with em (invI a)
  cantor .(I x) | inl (inv x refl) = x (I x) -> Empty
  cantor a | inr b = One

  CANTOR : Set
  CANTOR = I cantor

  no : cantor CANTOR -> Empty
  no p = no' p where

    no' : cantor CANTOR -> Empty
    no' with em (invI CANTOR)
    no' | inl (inv .cantor refl) = λ q -> q p  -- injectivity is used here
    no' | inr b = λ q -> b (inv cantor refl)

  yes : cantor CANTOR
  yes with em (invI CANTOR)
  yes | inl (inv .cantor refl) = no
  yes | inr b = one

  Ω : Empty
  Ω = no yes
